// /tmp/build-stella/stella-3.0.0.beta/native/cpp/stella/cpp-output.hh

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/



namespace stella {

// Global declarations:
extern DECLARE_STELLA_SPECIAL(oCPP_INDENT_CHARSo, int );
extern DECLARE_STELLA_SPECIAL(oOUTPUTTINGDEFPRINTpo, boolean );

// Function signatures:
Object* cpp_output_to_string_expander(Cons* statement);
void cpp_output_parse_tree(Cons* constree);
Cons* cpp_flatten_statements(Cons* statements);
Cons* cpp_prognify_statement(Object* statement);
Cons* cpp_statement_to_list(Object* statement);
void cpp_output_statement(Object* statement);
void cpp_output_verbatim(String_Wrapper* verbatimstatement);
void cpp_output_comment(String_Wrapper* tree);
void cpp_output_dereference(Cons* tree);
void cpp_output_array_reference(Cons* tree);
void cpp_output_cast(Cons* tree);
void cpp_output_signal(Cons* tree);
void cpp_output_handler_case(Cons* tree);
void cpp_output_catch(Cons* tree);
void cpp_output_unwind_protect(Cons* tree);
void cpp_output_global_declaration(Cons* global);
void cpp_output_variable_definition(Cons* variable);
void cpp_output_funcall_function_signature(Cons* signature);
void cpp_output_method_code_call_signature(Cons* signature);
void cpp_output_funcall(Cons* funcall);
void cpp_output_method_code_call(Cons* methodcall);
void cpp_output_break();
void cpp_output_continue();
boolean last_statement_is_returnP(Cons* statements);
void cpp_output_case(Cons* renamed_Case);
void cpp_output_cond(Cons* cond);
boolean cpp_prognP(Object* tree);
boolean cpp_blockP(Object* tree);
void cpp_output_if(Cons* tree);
void cpp_output_when(Cons* tree);
void cpp_output_unless(Cons* tree);
void cpp_output_assignment(Cons* assignment);
void cpp_output_loop(Cons* loop);
void cpp_output_while(Cons* loop);
void cpp_output_foreach(Cons* loop);
void cpp_output_function_pointer(String_Wrapper* functionname);
void cpp_output_method_pointer(String_Wrapper* methodname);
void cpp_output_slot_value(Cons* statement);
void cpp_output_referenced_slot_value(Cons* statement);
void cpp_output_slot_value_setter(Cons* statement);
void cpp_output_make(Cons* statement);
void cpp_bump_indent();
void cpp_unbump_indent();
char* replace_character_with_substring(char* string, char* renamed_New, char character);
void string_cpp_output_literal(char* string);
void cpp_output_identifier(String_Wrapper* identifier);
void cpp_output_atomic_expression(Object* atom);
void cpp_indent();
boolean cpp_output_semicolonP(Cons* statement);
boolean cpp_indent_statementP(Cons* statement);
boolean illegal_cpp_statementP(Cons* statement);
void cpp_output_statements(Cons* statementlist);
void cpp_maybe_output_statement_with_parentheses(Object* statement);
void cpp_output_stream_print_items(Cons* items);
void cpp_output_print_stream(Cons* exps);
void cpp_output_print_native_stream(Cons* exps);
boolean cpp_indentable_binary_operatorP(String_Wrapper* renamed_Operator);
boolean cpp_commutative_binary_operatorP(String_Wrapper* renamed_Operator);
boolean cpp_binary_operatorP(Object* statement);
boolean cpp_operatorP(Object* statement);
boolean cpp_assignmentP(Cons* statement);
void cpp_output_unary_operator(Cons* expression);
boolean cpp_nested_operator_needs_parenthesesP(String_Wrapper* op, Object* nested);
void cpp_help_output_binary_operator(Cons* expression, int nestlevel);
void cpp_output_binary_operator(Cons* expression);
void cpp_output_ternary_operator(Cons* expression);
void cpp_output_statement_line(Cons* statement);
void cpp_output_return(Cons* returnstatement);
void cpp_output_type_expression(Cons* typeexpression);
void cpp_output_typed_entity(Object* type, Object* entity, Object* initialvalue);
void cpp_output_declarations(Keyword* accesscontrolmode, Cons* declarations);
void cpp_output_signature(Cons* signature, boolean outputmethodclassP);
void cpp_output_signatures(Keyword* accesscontrolmode, Cons* signatures);
void cpp_output_definitions(Keyword* accesscontrolmode, Cons* definitions);
void cpp_output_progn(Cons* progn);
void cpp_output_block(Cons* block);
void cpp_output_with_process_lock(Cons* synch);
void cpp_output_static_member_vars(String_Wrapper* renamed_Class, Cons* declarations);
void cpp_output_derived_classes(Cons* classlist);
void cpp_output_template_parameters(Cons* parameters);
boolean cpp_output_template_classesP();
void cpp_output_class(Cons* classdef);
void cpp_output_formal_parameters(Cons* parameters);
boolean cpp_argument_is_streamP(Object* arg);
void cpp_output_one_actual_parameter(Object* parameter);
void cpp_output_actual_parameters(Cons* parameters);
void cpp_output_method_setter_call(Cons* methodsettercall);
void cpp_output_method_call(Cons* methodcall);
void cpp_output_referenced_method_call(Cons* methodcall);
void cpp_output_function_call(Cons* functioncall);
void cpp_output_defprint_signature(Cons* defprint);
void cpp_output_defprint(Cons* defprint);
void cpp_output_function_signature(Cons* function);
void cpp_output_function(Cons* function);
void help_startup_cpp_output1();
void help_startup_cpp_output2();
void help_startup_cpp_output3();
void startup_cpp_output();

// Auxiliary global declarations:
extern Symbol* SYM_CPP_OUTPUT_STELLA_VRLET;
extern Symbol* SYM_CPP_OUTPUT_STELLA_STRING;
extern Symbol* SYM_CPP_OUTPUT_STELLA_NULL;
extern Symbol* SYM_CPP_OUTPUT_STELLA_SPECIAL;
extern Symbol* SYM_CPP_OUTPUT_STELLA_oCURRENT_STREAMo;
extern Symbol* SYM_CPP_OUTPUT_STELLA_NEW;
extern Symbol* SYM_CPP_OUTPUT_STELLA_OUTPUT_STRING_STREAM;
extern Symbol* SYM_CPP_OUTPUT_STELLA_SETQ;
extern Symbol* SYM_CPP_OUTPUT_STELLA_THE_STRING;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CAST;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_OUTPUT_TO_STRING;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_OUTPUT_TO_STRING_EXPANDER;
extern Surrogate* SGT_CPP_OUTPUT_STELLA_CONS;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_PROGN;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_STATEMENTS;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_COMMENT;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_CLASS;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_HANDLER_CASE;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_CATCH;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_SIGNAL;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_UNWIND_PROTECT;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_VERBATIM;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_CAST;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_GLOBAL;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_SPECIAL;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_LOCAL;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_TYPE;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_DEREFERENCE;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_ARRAY_REFERENCE;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_WITH_PROCESS_LOCK;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_BREAK;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_CONTINUE;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_IF;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_FUNCTION_SIGNATURE;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_METHOD_SIGNATURE;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_COND;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_CASE;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_WHEN;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_UNLESS;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_ASSIGN;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_LOOP;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_WHILE;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_FOREACH;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_BLOCK;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_IDENT;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_PRINT_STREAM;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_PRINT_NATIVE_STREAM;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_LITERAL;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_FUNCTION;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_METHOD;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_RETURN;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_SYMBOL;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_MAKE;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_FUNCALL;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_METHOD_CODE_CALL;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_FUNCTION_POINTER;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_METHOD_POINTER;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_SLOT_VALUE;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_REFERENCED_SLOT_VALUE;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_SLOT_VALUE_SETTER;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_DECLARATIONS;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_DEFINITIONS;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_SIGNATURES;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_UNARY_OP;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_BINARY_OP;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_TERNARY_OP;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_FUNCTION_CALL;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_METHOD_SETTER_CALL;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_METHOD_CALL;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_REFERENCED_METHOD_CALL;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_ACTUALS;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_DEFPRINT;
extern Keyword* KWD_CPP_OUTPUT_UNBIND_WITH_DESTRUCTORS;
extern Symbol* SYM_CPP_OUTPUT_STELLA_NEWLINE;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_NULL_VALUE;
extern Symbol* SYM_CPP_OUTPUT_STELLA_ASSIGN;
extern Symbol* SYM_CPP_OUTPUT_STELLA_SCOLON;
extern Symbol* SYM_CPP_OUTPUT_STELLA_LPAREN;
extern Symbol* SYM_CPP_OUTPUT_STELLA_RPAREN;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_NEW;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_THROW;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_STANDARD_OUT;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_STANDARD_ERROR;
extern Keyword* KWD_CPP_OUTPUT_PUBLIC;
extern Keyword* KWD_CPP_OUTPUT_PRIVATE;
extern Keyword* KWD_CPP_OUTPUT_PROTECTED;
extern Keyword* KWD_CPP_OUTPUT_CPP_STANDALONE;
extern Symbol* SYM_CPP_OUTPUT_STELLA_CPP_VAR_ARGS;
extern Symbol* SYM_CPP_OUTPUT_STELLA_STARTUP_CPP_OUTPUT;
extern Symbol* SYM_CPP_OUTPUT_STELLA_METHOD_STARTUP_CLASSNAME;


} // end of namespace stella
