// /tmp/build-stella/stella-3.0.0.beta/native/cpp/stella/defclass.hh

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/



namespace stella {

// Global declarations:
extern DECLARE_STELLA_SPECIAL(oRECYCLING_ENABLEDpo, boolean );
extern List* oALL_RECYCLE_LISTSo;
extern int oMAX_RECYCLE_LIST_BYTESo;
extern int oRECYCLE_LISTS_MAINTENANCE_INTERVALo;
extern int oRECYCLE_LISTS_MAINTENANCE_TIMERo;
extern Hash_Table* oCURRENTLY_RECYCLED_ITEMSo;
extern boolean oTRANSLATE_WITH_RECYCLE_LIST_DEBUGGINGpo;

// Function signatures:
Object* type_to_null_value_tree(Surrogate* type);
Object* type_to_walked_null_value_tree(Surrogate* type);
Cons* yield_cons_list_from_sequence(Sequence* sequence);
Cons* yield_define_stella_class(Class* renamed_Class);
boolean create_native_classP(Class* renamed_Class);
boolean exception_classP(Class* renamed_Class);
void warn_about_multiple_parents(Class* renamed_Class);
void warn_about_non_direct_supers(Class* renamed_Class);
boolean space_saver_slot_allocationP(Storage_Slot* slot);
boolean dynamic_slotP(Storage_Slot* slot);
boolean class_slotP(Storage_Slot* slot);
boolean redundant_slotP(Storage_Slot* slot);
boolean native_slotP(Storage_Slot* slot);
boolean native_methodP(Method_Slot* slot);
boolean mixin_slotP(Slot* self);
boolean mixin_methodP(Slot* self);
Storage_Slot* canonical_slot(Storage_Slot* slot);
boolean unknown_typeP(Surrogate* type);
boolean slot_has_unknown_typeP(Storage_Slot* slot, Class* renamed_Class);
Class* native_storage_slot_home(Storage_Slot* slot, Class* renamed_Class);
Class* native_slot_home(Slot* slot, Class* renamed_Class);
boolean method_contains_unknown_typeP(Method_Slot* method);
boolean method_contains_anchored_typeP(Method_Slot* method);
Symbol* yield_recycle_list_name(Class* renamed_Class);
Storage_Slot* recycle_slot(Class* renamed_Class);
boolean use_free_listP(Class* renamed_Class);
boolean use_sweep_listP(Class* renamed_Class);
boolean decided_to_recycleP(Class* renamed_Class);
int compute_recycled_item_size(Class* renamed_Class);
Cons* yield_recycle_list_definitions(Class* renamed_Class);
Cons* yield_make_trees(Class* renamed_Class);
Symbol* yield_constructor_name(Class* renamed_Class);
Cons* yield_creation_trees(Class* renamed_Class);
Cons* yield_terminate_object_trees(Class* renamed_Class);
Cons* yield_creation_or_reuse_trees(Class* renamed_Class);
Cons* yield_creation_or_reuse_trees_from_free_list(Class* renamed_Class);
Cons* yield_creation_or_reuse_trees_from_sweep_list(Class* renamed_Class);
Cons* yield_creation_or_reuse_trees_from_free_or_sweep_list(Class* renamed_Class);
void mark_direct_equivalent_slot(Slot* slot);
boolean is_context_sensitive_slotP(Storage_Slot* slot);
Cons* yield_initial_value_assignment(Storage_Slot* slot, Keyword* mode);
Cons* yield_initial_value_assignments(Class* renamed_Class, Keyword* mode);
Cons* yield_local_initial_value_assignments(Class* renamed_Class);
Cons* yield_initializer_trees(Class* renamed_Class);
Cons* yield_constructor_body(Class* renamed_Class, Cons* requiredassignments);
Cons* yield_constructor_definition(Class* renamed_Class);
Cons* yield_exception_constructor_body(Class* renamed_Class, Symbol* messageparameter, Cons* requiredassignments);
Cons* yield_exception_constructor_definition(Class* renamed_Class);
Cons* yield_destructor_definitions(Class* renamed_Class);
void create_constructor_and_destructor_units(Class* renamed_Class);
boolean parameterized_classP(Class* renamed_Class);
boolean class_with_initializerP(Class* renamed_Class);
Symbol* yield_initializer_name(Class* renamed_Class);
Cons* yield_initializer_definition(Class* renamed_Class);
void create_cpp_constructor_unit(Class* renamed_Class);
boolean cpp_constructorP(Method_Slot* method);
Recycle_List* create_recycle_list(Surrogate* classtype, int itemsize);
void clear_recycle_list(Recycle_List* list);
void clear_recycle_lists();
void print_recycle_lists();
void maintain_recycle_lists();
int recycle_list_size(Recycle_List* list);
int total_recycle_lists_size();
boolean recycle_list_sizeL(Recycle_List* list1, Recycle_List* list2);
void reduce_recycle_list_size(Recycle_List* list, double fraction);
void sweep_transients();
List* make_non_recycled_list();
void register_recycled_item(Object* item);
void unregister_recycled_item(Object* item);
void start_recycle_list_debugging();
void stop_recycle_list_debugging();
boolean recycle_list_debugging_enabledP();
boolean translate_with_recycle_list_debuggingP();
Cons* yield_register_recycled_item_trees();
Cons* yield_unregister_recycled_item_trees();
boolean has_non_null_default_valueP(Storage_Slot* slot);
boolean system_defined_slot_readerP(Storage_Slot* slot);
boolean system_defined_slot_writerP(Storage_Slot* slot);
Object* yield_slot_type_tree(Storage_Slot* slot);
Symbol* yield_hardwired_slot_variable(Storage_Slot* slot);
Cons* yield_hardwired_slot_reader_body(Storage_Slot* slot, Cons*& _return1);
void finalize_auxiliary_method(Method_Slot* method);
Cons* wrap_with_default_value_and_return_code(Storage_Slot* slot, Object* defaultexpression);
Cons* yield_slot_reader_tree(Storage_Slot* slot, Class* renamed_Class);
Cons* yield_slot_writer_tree(Storage_Slot* slot, Class* renamed_Class);
boolean slot_value_is_bare_literalP(Slot* slot);
boolean generically_accessible_typeP(Surrogate* type);
boolean generic_slot_readerP(Storage_Slot* slot);
boolean generic_slot_writerP(Storage_Slot* slot);
boolean slot_access_methodP(Storage_Slot* slot);
Symbol* yield_generic_slot_accessor_name(Class* renamed_Class);
Cons* yield_generic_slot_accessor_definition(Class* renamed_Class);
void create_generic_slot_accessor_unit(Class* renamed_Class);
Cons* yield_generic_slot_accessor_attachment(Class* renamed_Class, Symbol* classref);
Cons* yield_mixin_class_users_tree(Class* renamed_Class);
Symbol* yield_mixin_slot_reader_name(Storage_Slot* slot);
Symbol* yield_mixin_slot_writer_name(Storage_Slot* slot);
Cons* yield_mixin_slot_reader_tree(Storage_Slot* slot);
Cons* yield_mixin_slot_writer_tree(Storage_Slot* slot);
Symbol* yield_native_slot_reader_name(Storage_Slot* slot);
Symbol* yield_native_slot_writer_name(Storage_Slot* slot);
Cons* yield_native_slot_reader_tree(Storage_Slot* slot, Class* renamed_Class);
Cons* yield_native_slot_writer_tree(Storage_Slot* slot, Class* renamed_Class);
void create_keyed_equality_method_unit(Class* renamed_Class);
boolean transient_objectP(Object* object);
void help_startup_defclass1();
void help_startup_defclass2();
void help_startup_defclass3();
void help_startup_defclass4();
void startup_defclass();

// Auxiliary global declarations:
extern Surrogate* SGT_DEFCLASS_STELLA_LITERAL;
extern Surrogate* SGT_DEFCLASS_STELLA_SECOND_CLASS_OBJECT;
extern Symbol* SYM_DEFCLASS_STELLA_NULL;
extern Symbol* SYM_DEFCLASS_STELLA_DEFINE_CLASS_FROM_STRINGIFIED_SOURCE;
extern Keyword* KWD_DEFCLASS_COMMON_LISP;
extern Symbol* SYM_DEFCLASS_STELLA_CLASS_CL_NATIVE_TYPE;
extern Keyword* KWD_DEFCLASS_IDL;
extern Symbol* SYM_DEFCLASS_STELLA_CLASS_IDL_NATIVE_TYPE;
extern Keyword* KWD_DEFCLASS_JAVA;
extern Symbol* SYM_DEFCLASS_STELLA_CLASS_JAVA_NATIVE_TYPE;
extern Keyword* KWD_DEFCLASS_CPP;
extern Keyword* KWD_DEFCLASS_CPP_STANDALONE;
extern Symbol* SYM_DEFCLASS_STELLA_CLASS_CPP_NATIVE_TYPE;
extern Surrogate* SGT_DEFCLASS_STELLA_NON_OBJECT;
extern Surrogate* SGT_DEFCLASS_STELLA_NATIVE_EXCEPTION;
extern Keyword* KWD_DEFCLASS_DYNAMIC;
extern Symbol* SYM_DEFCLASS_STELLA_SLOT_INITIAL_VALUE;
extern Keyword* KWD_DEFCLASS_BIT;
extern Surrogate* SGT_DEFCLASS_STELLA_BOOLEAN;
extern Keyword* KWD_DEFCLASS_CLASS;
extern Symbol* SYM_DEFCLASS_STELLA_SLOT_RENAMES;
extern Surrogate* SGT_DEFCLASS_STELLA_UNKNOWN;
extern Symbol* SYM_DEFCLASS_STELLA_SLOT_TYPE_SPECIFIER;
extern Surrogate* SGT_DEFCLASS_STELLA_ANCHORED_TYPE_SPECIFIER;
extern Symbol* SYM_DEFCLASS_STELLA_NEXT_SWEEP_LIST_OBJECT;
extern Keyword* KWD_DEFCLASS_FREE_LIST;
extern Keyword* KWD_DEFCLASS_FREE_AND_SWEEP_LIST;
extern Keyword* KWD_DEFCLASS_SWEEP_LIST;
extern Symbol* SYM_DEFCLASS_STELLA_CLASS_CREATOR;
extern Keyword* KWD_DEFCLASS_USE_COMMON_LISP_STRUCTS;
extern Keyword* KWD_DEFCLASS_USE_COMMON_LISP_VECTOR_STRUCTS;
extern Symbol* SYM_DEFCLASS_STELLA_DEFGLOBAL;
extern Symbol* SYM_DEFCLASS_STELLA_RECYCLE_LIST;
extern Symbol* SYM_DEFCLASS_STELLA_OF;
extern Symbol* SYM_DEFCLASS_STELLA_CREATE_RECYCLE_LIST;
extern Symbol* SYM_DEFCLASS_STELLA_SETQ;
extern Symbol* SYM_DEFCLASS_STELLA_SELF;
extern Symbol* SYM_DEFCLASS_STELLA_MAKE;
extern Symbol* SYM_DEFCLASS_STELLA_WHEN;
extern Symbol* SYM_DEFCLASS_STELLA_DEFINEDp;
extern Symbol* SYM_DEFCLASS_STELLA_FREE;
extern Symbol* SYM_DEFCLASS_STELLA_DYNAMIC_SLOTS;
extern Symbol* SYM_DEFCLASS_STELLA_CLEAR;
extern Symbol* SYM_DEFCLASS_STELLA_UNLESS;
extern Symbol* SYM_DEFCLASS_STELLA_RETURN;
extern Keyword* KWD_DEFCLASS_FORCE_NULL_VALUE;
extern Keyword* KWD_DEFCLASS_NULL_VALUE_ONLY;
extern Symbol* SYM_DEFCLASS_STELLA_AND;
extern Symbol* SYM_DEFCLASS_STELLA_oRECYCLING_ENABLEDpo;
extern Symbol* SYM_DEFCLASS_STELLA_COND;
extern Symbol* SYM_DEFCLASS_STELLA___;
extern Symbol* SYM_DEFCLASS_STELLA_CURRENT_LENGTH;
extern Symbol* SYM_DEFCLASS_STELLA_OTHERWISE;
extern Symbol* SYM_DEFCLASS_STELLA_RECYCLED_ITEMS;
extern Symbol* SYM_DEFCLASS_STELLA_POP;
extern Symbol* SYM_DEFCLASS_STELLA_LIST_OF_RECYCLED_ITEMS;
extern Symbol* SYM_DEFCLASS_STELLA_SETF;
extern Symbol* SYM_DEFCLASS_STELLA_SLOT_VALUE;
extern Symbol* SYM_DEFCLASS_STELLA_UNUSED_ITEMS;
extern Symbol* SYM_DEFCLASS_STELLA_ALL_ITEMS;
extern Symbol* SYM_DEFCLASS_STELLA_ii;
extern Symbol* SYM_DEFCLASS_STELLA_e;
extern Symbol* SYM_DEFCLASS_STELLA_oRECYCLE_LISTS_MAINTENANCE_TIMERo;
extern Symbol* SYM_DEFCLASS_STELLA_MAINTAIN_RECYCLE_LISTS;
extern Keyword* KWD_DEFCLASS_INITIAL_VALUE_ONLY;
extern Keyword* KWD_DEFCLASS_ANY_INITIAL_VALUE;
extern Keyword* KWD_DEFCLASS_CONTEXT_SENSITIVEp;
extern Symbol* SYM_DEFCLASS_STELLA_FALSE;
extern Symbol* SYM_DEFCLASS_STELLA_CLASS_INITIALIZER;
extern Symbol* SYM_DEFCLASS_STELLA_RUN_CONSTRUCTOR_DEMONS;
extern Symbol* SYM_DEFCLASS_STELLA_DEFUN;
extern Keyword* KWD_DEFCLASS_CONSTRUCTORp;
extern Symbol* SYM_DEFCLASS_STELLA_TRUE;
extern Keyword* KWD_DEFCLASS_PUBLICp;
extern Symbol* SYM_DEFCLASS_STELLA_LET;
extern Symbol* SYM_DEFCLASS_STELLA_CLASS_DESTRUCTOR;
extern Symbol* SYM_DEFCLASS_STELLA_DEFMETHOD;
extern Surrogate* SGT_DEFCLASS_STELLA_STANDARD_OBJECT;
extern Symbol* SYM_DEFCLASS_STELLA_PUSH;
extern Symbol* SYM_DEFCLASS_STELLA_SWEEP;
extern Symbol* SYM_DEFCLASS_STELLA_UNUSED;
extern Symbol* SYM_DEFCLASS_STELLA_WHILE;
extern Symbol* SYM_DEFCLASS_STELLA_NOT;
extern Symbol* SYM_DEFCLASS_STELLA_EQLp;
extern Symbol* SYM_DEFCLASS_STELLA_UNMAKE;
extern Surrogate* SGT_DEFCLASS_STELLA_VOID;
extern Surrogate* SGT_DEFCLASS_STELLA_TRANSIENT_MIXIN;
extern Symbol* SYM_DEFCLASS_STELLA_RECYCLE_LIST_DEBUGGING_ENABLEDp;
extern Symbol* SYM_DEFCLASS_STELLA_REGISTER_RECYCLED_ITEM;
extern Symbol* SYM_DEFCLASS_STELLA_UNREGISTER_RECYCLED_ITEM;
extern Keyword* KWD_DEFCLASS_NULL_WRAPPER;
extern Symbol* SYM_DEFCLASS_STELLA_INLINE_WRAP_BOOLEAN;
extern Symbol* SYM_DEFCLASS_STELLA_FALSE_WRAPPER;
extern Symbol* SYM_DEFCLASS_STELLA_ANSWER;
extern Symbol* SYM_DEFCLASS_STELLA_IF;
extern Symbol* SYM_DEFCLASS_STELLA_NULLp;
extern Symbol* SYM_DEFCLASS_STELLA_PROGN;
extern Symbol* SYM_DEFCLASS_STELLA_ERROR;
extern Keyword* KWD_DEFCLASS_AUXILIARYp;
extern Symbol* SYM_DEFCLASS_STELLA_VALUE;
extern Symbol* SYM_DEFCLASS_STELLA_IGNORE;
extern Surrogate* SGT_DEFCLASS_STELLA_OBJECT;
extern Keyword* KWD_DEFCLASS_WRAP_FUNCTION;
extern Symbol* SYM_DEFCLASS_STELLA_CAST;
extern Symbol* SYM_DEFCLASS_STELLA_SETVALUEp;
extern Surrogate* SGT_DEFCLASS_STELLA_DYNAMIC_SLOTS_MIXIN;
extern Symbol* SYM_DEFCLASS_STELLA_SLOTNAME;
extern Symbol* SYM_DEFCLASS_STELLA_QUOTE;
extern Symbol* SYM_DEFCLASS_STELLA_CASE;
extern Symbol* SYM_DEFCLASS_STELLA_SET_DYNAMIC_SLOT_VALUE;
extern Symbol* SYM_DEFCLASS_STELLA_LOOKUP;
extern Symbol* SYM_DEFCLASS_STELLA_OBJECT;
extern Symbol* SYM_DEFCLASS_STELLA_SYMBOL;
extern Symbol* SYM_DEFCLASS_STELLA_BOOLEAN;
extern Symbol* SYM_DEFCLASS_STELLA_CLASS_SLOT_ACCESSOR_CODE;
extern Symbol* SYM_DEFCLASS_STELLA_THE_CODE;
extern Keyword* KWD_DEFCLASS_FUNCTION;
extern Symbol* SYM_DEFCLASS_STELLA_TYPECASE;
extern Symbol* SYM_DEFCLASS_STELLA_EQp;
extern Symbol* SYM_DEFCLASS_STELLA_OTHER;
extern Symbol* SYM_DEFCLASS_STELLA_EQUAL;
extern Symbol* SYM_DEFCLASS_STELLA_STARTUP_DEFCLASS;
extern Symbol* SYM_DEFCLASS_STELLA_METHOD_STARTUP_CLASSNAME;


} // end of namespace stella
