// /tmp/build-stella/stella-3.0.0.beta/native/cpp/stella/java-translate.hh

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/



namespace stella {

// Global declarations:
extern DECLARE_STELLA_SPECIAL(oVARARGSTATEMENTSo, Cons* );
extern DECLARE_STELLA_SPECIAL(oVARARGDECLSo, Cons* );
extern DECLARE_STELLA_SPECIAL(oCURRENTVARARGINDEXo, int );
extern Key_Value_List* oJAVA_OPERATOR_TABLEo;
extern char* oJAVA_CHARACTER_SUBSTITUTION_TABLEo;
extern String_Hash_Table* oJAVA_RESERVED_WORD_TABLEo;
extern DECLARE_STELLA_SPECIAL(oJAVA_LOOP_NAMEo, Symbol* );
extern DECLARE_STELLA_SPECIAL(oJAVA_LOOP_NAME_USEDpo, boolean );
extern Key_Value_List* oJAVA_PRIMITIVE_ARRAY_TYPE_NAMESo;

// Function signatures:
char* java_yield_flotsam_class_name(Module* mod);
char* java_yield_full_native_class_name();
Cons* java_translate_unit(Translation_Unit* unit);
Cons* java_translate_define_global_variable_unit(Translation_Unit* unit);
Cons* wrap_method_body_with_java_auxiliary_declarations(Cons* methodbody, Cons* declarations);
boolean java_synchronized_methodP(Method_Slot* method);
Cons* java_translate_define_method_unit(Translation_Unit* unit);
Cons* java_translate_defprint_unit(Translation_Unit* unit);
Cons* java_translate_list_of_trees(Cons* trees);
Object* java_translate_a_tree(Object* tree);
Cons* java_lookup_operator_table(Symbol* renamed_Operator);
char* java_create_character_substitution_table();
char* java_substitute_forbidden_characters(char* name, Keyword* caseconvention);
char* java_change_case(Generalized_Symbol* symbol, Keyword* caseconvention);
boolean java_literalP(Standard_Object* typespec);
String_Wrapper* java_native_literal_wrapper_names(Standard_Object* typespec, String_Wrapper*& _return1);
String_Wrapper* java_special_setter_name(Standard_Object* typespec);
String_Wrapper* java_translate_symbol_constant_name(Generalized_Symbol* symbol);
String_Wrapper* java_translate_symbol_constant_id(Generalized_Symbol* symbol);
String_Wrapper* java_translate_symbol_name(Symbol* symbol);
String_Wrapper* java_translate_symbol_id(Symbol* symbol);
String_Wrapper* java_translate_surrogate_name(Surrogate* surrogate);
String_Wrapper* java_translate_surrogate_id(Surrogate* surrogate);
String_Wrapper* java_translate_keyword_name(Keyword* keyword);
String_Wrapper* java_translate_keyword_id(Keyword* keyword);
String_Wrapper* java_translate_class_namestring(String_Wrapper* namestring);
String_Wrapper* java_translate_class_name(Generalized_Symbol* namesymbol);
boolean in_current_java_packageP(Module* module);
String_Wrapper* java_translate_type_spec(Standard_Object* typespec);
String_Wrapper* java_translate_array_type(Parametric_Type_Specifier* arraytype);
String_Wrapper* java_translate_array_of_type_spec(Standard_Object* typespec, boolean fullyqualifiedP);
String_Wrapper* java_yield_renamed_reserved_word(Symbol* word);
String_Hash_Table* java_create_reserved_word_table();
char* java_lookup_reserved_word_table(char* word);
char* java_translate_namestring(char* namestring);
String_Wrapper* java_translate_name(Symbol* namesymbol);
Cons* java_translate_special_tree(Cons* tree);
Cons* java_translate_verbatim_tree(Cons* tree);
Object* java_translate_inline_call_tree(Cons* tree);
Object* java_translate_catch(Cons* tree);
Object* java_translate_throw(Cons* tree);
Cons* java_translate_unwind_protect(Cons* tree);
Cons* java_translate_signal(Cons* tree);
Cons* java_translate_handler_case(Cons* tree);
Cons* java_translate_handle_exception(Cons* tree);
Cons* java_translate_void_sys(Cons* tree);
Cons* java_translate_typed_sys(Cons* tree);
Object* java_translate_bad_sys(Cons* tree);
Object* java_translate_setq_tree(Cons* tree);
Object* java_translate_sys_referenced_slot_value(Cons* tree);
Cons* java_translate_sys_slot_value_setter(Cons* tree);
Cons* java_translate_sys_slot_value(Cons* tree);
Cons* java_translate_progn(Cons* tree);
Cons* java_translate_with_process_lock(Cons* tree);
Cons* java_translate_loop(Cons* tree);
Cons* java_translate_argument_list_iterator(Cons* iteratorbindings, Cons* cursorbindings, Cons* body);
Cons* java_translate_foreach_tree(Cons* tree);
Cons* java_translate_let_tree(Cons* tree);
Object* java_translate_startup_time_progn(Cons* tree);
Cons* java_translate_cast(Cons* tree);
Cons* java_translate_return_tree(Cons* tree);
Cons* java_translate_break(Cons* tree);
Cons* java_translate_continue(Cons* tree);
Cons* java_translate_if_tree(Cons* tree);
boolean java_symbol_caseP(Object* keyform);
Cons* java_yield_symbol_id_form(int symbolid);
Cons* java_translate_condition(Cons* condition, boolean symbolcasep);
Cons* java_translate_case_tree(Cons* tree);
Cons* java_translate_cond_tree(Cons* tree);
Cons* java_translate_while(Cons* tree);
Cons* java_translate_choose_tree(Cons* tree);
Cons* java_translate_when_tree(Cons* tree);
Cons* java_translate_unless_tree(Cons* tree);
Cons* java_translate_make_tree(Cons* tree);
Cons* java_translate_sys_new(Cons* tree);
Cons* java_translate_new_array(Cons* tree);
Cons* java_translate_mv_setq(Cons* tree);
Cons* java_translate_mv_function_call(Cons* functioncall, Symbol* mvvectorname);
Cons* java_translate_code_signature(Cons* signature);
Cons* java_translate_with_native_wrapper(Object* tree, Standard_Object* type);
Cons* java_translate_actual_parameters_with_native_wrappers(Cons* trees, Cons* parametertypes);
Cons* java_wrap_with_native_value_extraction(Cons* tree, Standard_Object* primaryreturntype);
Cons* java_translate_object_to_return_type(Cons* tree, Standard_Object* returntype);
Cons* java_translate_call_function_code(Cons* tree);
Cons* java_translate_call_method_code(Cons* tree);
char* java_package_prefix(Module* module, char* separator);
String_Wrapper* java_yield_fully_qualified_type_name(Standard_Object* typespec);
String_Wrapper* java_yield_translated_class_and_function_names(Method_Slot* f, String_Wrapper*& _return1);
char* java_yield_translated_class_and_method_names(Standard_Object* owner, Method_Slot* f, char*& _return1);
Cons* java_translate_class_object_lookup(char* classname);
Cons* java_yield_class_object_array_expression(Standard_Object* typespec, int ndimensions);
Cons* java_yield_class_object_expression(Standard_Object* typespec);
char* yield_class_object_lookup_name_for_native_type(char* nativetype);
Cons* java_translate_param_type_specifications(Method_Slot* fn, Standard_Object* owner);
Object* java_translate_the_code(Cons* tree);
String_Wrapper* java_translate_function_name(Method_Slot* function);
Object* java_translate_sys_pointer_to_function(Cons* tree);
Object* java_translate_ignore_tree(Cons* tree);
boolean java_stream_is_standard_outputP(Object* tree);
Cons* java_translate_print_stream(Cons* tree);
Cons* java_translate_print_native_stream(Cons* tree);
Cons* java_translate_null();
Cons* java_translate_eol();
char* java_prepend_global_class_name(char* namestring, Module* module);
String_Wrapper* java_translate_global_name(Symbol* namesymbol, boolean definitionP);
Cons* java_translate_general_symbol(Symbol* tree);
Object* java_translate_method_parameter(Symbol* name, Standard_Object* type, Method_Slot* method);
Cons* java_translate_return_parameter();
Cons* java_translate_method_parameters(Method_Slot* method);
boolean zero_argument_functionP(Method_Slot* method);
boolean java_method_object_defined_on_native_typeP(Method_Slot* method);
boolean java_method_object_is_overloaded_functionP(Method_Slot* method);
boolean java_method_object_is_functionP(Method_Slot* method);
boolean java_function_in_different_moduleP(Method_Slot* method);
Symbol* java_create_overloaded_function_name(Symbol* functionname, Surrogate* classtype);
Cons* java_delete_quoted_null_statements(Cons* trees);
Cons* java_wrap_method_body_with_vararg_declarations(Cons* methodbody);
Cons* java_wrap_method_body_with_vararg_value_setup(Cons* methodbody);
Cons* java_translate_method(Method_Slot* method);
String_Wrapper* java_translate_variable_length_arg_name(Symbol* namesymbol, int parameternumber);
Cons* java_translate_variable_length_actuals(Cons* actuals, Method_Slot* unused_method);
Cons* java_translate_actual_parameters(Cons* tree);
char* java_yield_class_name_for_function(Method_Slot* function);
Cons* java_translate_function_call(Cons* tree, Method_Slot* method);
Cons* java_translate_defined_or_null(Surrogate* classtype, Object* object, boolean nullP);
Cons* java_translate_method_call(Cons* tree);
Cons* java_translate_operator_tree(Cons* tree);
Cons* java_translate_operator_call(Cons* operatornames, Cons* arguments, int arity);
Cons* java_translate_aref_method_call(Symbol* renamed_Operator, Surrogate* owner, Cons* arguments);
void help_startup_java_translate1();
void help_startup_java_translate2();
void help_startup_java_translate3();
void help_startup_java_translate4();
void help_startup_java_translate5();
void help_startup_java_translate6();
void startup_java_translate();

// Auxiliary global declarations:
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_FLOTSAM_CLASS;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_GLOBAL_VARIABLE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_CLASS;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_TYPE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_METHOD;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_MACRO;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_PRINT_METHOD;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_STARTUP_TIME_PROGN;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_VERBATIM;
extern Keyword* KWD_JAVA_TRANSLATE_UNBOUND_SPECIAL_VARIABLE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_SPECIAL;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_TYPE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_GLOBAL;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_STATEMENTS;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_BLOCK;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_APIp;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_THIS;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_DOCUMENTATION;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_COMMENT;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_FUNCTION;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_METHOD;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SELF;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_CONS;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SPECIAL;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_CATCH;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_THROW;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SYS_UNWIND_PROTECT;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SYS_SIGNAL;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SYS_HANDLER_CASE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SYS_HANDLE_EXCEPTION;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_VOID_SYS;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_TYPED_SYS;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_BAD_SYS;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SETQ;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SYS_SLOT_VALUE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SYS_REFERENCED_SLOT_VALUE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SYS_SLOT_VALUE_SETTER;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SYS_CALL_METHOD;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SYS_CALL_FUNCTION;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_PROGN;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_WITH_PROCESS_LOCK;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_LOOP;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SYS_FOREACH;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_LET;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_CAST;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SAFE_CAST;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_RETURN;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_BREAK;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_CONTINUE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_WHILE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_IF;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_CHOOSE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_WHEN;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_UNLESS;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_AND;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_OR;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_NOT;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_EQp;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_g;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_ge;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_l;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_le;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_ii;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA___;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_COND;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_CASE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_MAKE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SYS_NEW;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_MV_SETQ;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SYS_CALL_FUNCTION_CODE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SYS_CALL_METHOD_CODE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SYS_INLINE_CALL;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_THE_CODE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SYS_POINTER_TO_FUNCTION;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_INLINE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_IGNORE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_PRINT_STREAM;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_PRINT_NATIVE_STREAM;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_KEY_VALUE_LIST;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_i;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA__;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_o;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_s;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_eg;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_el;
extern Keyword* KWD_JAVA_TRANSLATE_UPPERCASE;
extern Keyword* KWD_JAVA_TRANSLATE_LOWERCASE;
extern Keyword* KWD_JAVA_TRANSLATE_CAPITALIZED;
extern Keyword* KWD_JAVA_TRANSLATE_UNESCAPED;
extern Keyword* KWD_JAVA_TRANSLATE_NO;
extern Keyword* KWD_JAVA_TRANSLATE_PRESERVE;
extern Keyword* KWD_JAVA_TRANSLATE_UPCASE;
extern Keyword* KWD_JAVA_TRANSLATE_CLEVER;
extern Keyword* KWD_JAVA_TRANSLATE_TITLECASEX;
extern Keyword* KWD_JAVA_TRANSLATE_TITLECASE;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_LITERAL;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_STRING;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_MUTABLE_STRING;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_CODE;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_BOOLEAN;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_INTEGER;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_SHORT_INTEGER;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_UNSIGNED_SHORT_INTEGER;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_BYTE;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_OCTET;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_THIRY_TWO_BIT_VECTOR;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_FLOAT;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_DOUBLE;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_CHARACTER;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_LONG_INTEGER;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_SINGLE_FLOAT;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_CLASS_JAVA_NATIVE_TYPE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_ANY_VALUE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_OBJECT;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_ABSTRACT;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_BOOLEAN;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_BYTE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_CHAR;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_CONST;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_DEFAULT;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_DO;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_DOUBLE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_ELSE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_EXTENDS;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_FINAL;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_FINALLY;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_FLOAT;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_FOR;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_GOTO;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_IMPLEMENTS;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_IMPORT;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_INSTANCEOF;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_INT;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_INTERFACE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_LONG;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_NATIVE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_NEW;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_PACKAGE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_PRIVATE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_PROTECTED;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_PUBLIC;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SHORT;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_STATIC;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SUPER;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SWITCH;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SYNCHRONIZED;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_THROWS;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_TRANSIENT;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_TRY;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_VOID;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_VOLATILE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_METHOD_CALL;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_IDENT;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_ACTUALS;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_UNWIND_PROTECT;
extern Keyword* KWD_JAVA_TRANSLATE_JAVA;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_VERBATIM;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_SIGNAL;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_HANDLER_CASE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_CATCH;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_FUNCTION_CALL;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_ASSIGN;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_SLOT_VALUE_SETTER;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_SLOT_VALUE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_PROGN;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_WITH_PROCESS_LOCK;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_NAMED_STATEMENT;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_LOOP;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_ARG_ENUM;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_WHILE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_CAST;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_ELEMENTS;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_OBJECT;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_LISP_CONS_ITERATOR;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_FOREACH;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_INTEGER_WRAPPER;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_FLOAT_WRAPPER;
extern Keyword* KWD_JAVA_TRANSLATE_WRAP_FUNCTION;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_AREF;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_MV_RETURNARRAY;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_RETURN;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_BREAK;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_CONTINUE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_IF;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_SYMBOL_ID;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_OTHERWISE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_CASE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_COND;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_WHEN;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_UNLESS;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_MAKE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_MAKE_ARRAY;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_NATIVE_OBJECT_POINTER;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_CALLER_MV_RETURNARRAY;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_FUNCTION_SIGNATURE;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_VOID;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_FUNCALL;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_METHOD_CODE_CALL;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_MODULE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_PACKAGE;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_ARGUMENT_LIST;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_METHOD_STARTUP_CLASSNAME;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_METHOD_NATIVEp;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_METHOD_CONSTRUCTORp;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_DOUBLE_FLOAT;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_UNSIGNED_LONG_INTEGER;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_THIRTY_TWO_BIT_VECTOR;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_TICKTOCK;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_NATIVE_DATE_TIME;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_ANONYMOUS_ARRAY;
extern Keyword* KWD_JAVA_TRANSLATE_FUNCTION;
extern Keyword* KWD_JAVA_TRANSLATE_METHOD;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_PRINT_STREAM;
extern Keyword* KWD_JAVA_TRANSLATE_WARN;
extern Keyword* KWD_JAVA_TRANSLATE_ERROR;
extern Keyword* KWD_JAVA_TRANSLATE_CONTINUABLE_ERROR;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_STANDARD_ERROR;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_STANDARD_OUT;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_PRINT_NATIVE_STREAM;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_EOL;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_EOL;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_LITERAL;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_NULL;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_METHOD_VARIABLE_ARGUMENTSp;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_GET_SYM;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_SYMBOL;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_GET_KWD;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_GET_SGT;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_NULL_INTEGER;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_NULL_FLOAT;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_NULL_SINGLE_FLOAT;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_NULL_CHARACTER;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_METHOD_SLOT;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_DEFINEDp;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_NULLp;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_CONCATENATE;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_AREF;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_AREF_SETTER;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_UNARY_OP;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_BINARY_OP;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_JAVA_TERNARY_OP;
extern Surrogate* SGT_JAVA_TRANSLATE_STELLA_ARRAY;
extern Symbol* SYM_JAVA_TRANSLATE_STELLA_STARTUP_JAVA_TRANSLATE;


} // end of namespace stella
