// /tmp/build-stella/stella-3.0.0.beta/native/cpp/stella/lists.hh

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/



namespace stella {

// Global declarations:
extern List* NIL_LIST;

// Function signatures:
boolean defined_listP(List* self);
boolean null_listP(List* self);
boolean terminate_listP(List* self);
List* map_null_to_nil_list(List* self);
boolean terminate_list_iteratorP(List_Iterator* self);
Object* search_plist(Cons* plist, Object* key);
Kv_Cons* kv_cons(Object* key, Object* value, Kv_Cons* rest);
void free_kv_cons(Kv_Cons* kvcons);
Kv_Cons* copy_kv_cons_list(Kv_Cons* kvconslist);
List* list(int values, ...);
Sequence* sequence(Surrogate* collectiontype, int values, ...);
Abstract_Dictionary* dictionary(Surrogate* collectiontype, int alternatingkeysandvalues, ...);
void print_key_value_list(Key_Value_List* self, ostream* stream);
void print_cons_list(Cons* list, ostream* stream);
void help_startup_lists1();
void startup_lists();

// Auxiliary global declarations:
extern Surrogate* SGT_LISTS_STELLA_LIST;
extern Surrogate* SGT_LISTS_STELLA_PROPERTY_LIST;
extern Surrogate* SGT_LISTS_STELLA_KEY_VALUE_LIST;
extern Surrogate* SGT_LISTS_STELLA_HASH_TABLE;
extern Symbol* SYM_LISTS_STELLA_STARTUP_LISTS;
extern Symbol* SYM_LISTS_STELLA_METHOD_STARTUP_CLASSNAME;


} // end of namespace stella
