// /tmp/build-stella/stella-3.0.0.beta/native/cpp/stella/modules.hh

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/



namespace stella {

// Global declarations:
extern Keyword* oSUBCONTEXT_REVISION_POLICYo;
extern DECLARE_STELLA_SPECIAL(oSHADOWEDSURROGATESo, Cons* );
extern Hook_List* oDEFINE_MODULE_HOOKSo;

// Function signatures:
Context* compute_context_or_module_from_pathname(char* pathname, boolean moduleP, boolean symbolnameP, int& _return1);
boolean component_matchP(char* component, char* string, int start, int end);
Module* compute_module_and_bare_name(char* name, char*& _return1);
char* qualified_name_module_name(char* qualifiedname);
char* qualified_name_bare_name(char* qualifiedname);
Module* dwim_module_and_bare_name(char* name, boolean warnP, char*& _return1);
Generalized_Symbol* intern_qualified_name(char* name, boolean enable_case_conversionP);
Context* get_stella_context(char* pathname, boolean warnP);
Module* get_stella_module(char* pathname, boolean warnP);
char* coerce_to_module_name(Object* namespec, boolean warnP);
Module* coerce_to_module(Object* object, boolean warnP);
Module* find_or_create_module(char* pathname);
Module* change_current_module(Module* module);
Context* change_current_context(Context* context);
Context* string_change_context(char* contextname);
Module* string_change_module(char* modulename);
void normalize_parent_modules(Module* self);
void inherit_supercontexts(Module* module);
void uninherit_supercontexts(Module* module);
void inherit_used_modules(Module* module);
void uninherit_used_modules(Module* module);
void finalize_module(Module* self);
void finalize_world(World* self);
void destroy_module(Module* self);
void help_destroy_module(Module* self);
void destroy_world(World* self);
void string_destroy_context(char* self);
void link_to_parent_module(Module* self, Module* parent, boolean insert_firstP);
void incorporate_module_name(Module* module, char* name);
void incorporate_includes_modules(Module* module, Object* includees);
void incorporate_uses_modules(Module* module, Object* usees);
void incorporate_module_options(Module* self, Cons* options);
void undefine_module(Module* oldmodule, Module* newmodule);
Module* define_module(char* name, Cons* options);
boolean identical_module_signaturesP(Module* oldmodule, Module* newmodule, char* newoptions);
Module* define_module_from_stringified_source(char* name, char* stringifiedoptions);
Cons* yield_define_module(Module* module);
void defmodule(Object* name, Cons* options);
void defmodule_evaluator_wrapper(Cons* arguments);
Module* in_module(Object* name);
World* create_world(Context* parentcontext, char* name);
World* push_world();
Context* pop_world();
All_Purpose_Iterator* all_subcontexts(Context* context, Keyword* traversal);
boolean all_subcontexts_nextP(All_Purpose_Iterator* self);
Iterator* all_contexts();
boolean filter_moduleP(Object* self, All_Purpose_Iterator* iterator);
Iterator* all_modules();
Iterator* all_included_modules(Module* self);
Iterator* visible_modules(Module* from);
boolean cardinal_moduleP(Module* self);
boolean visible_fromP(Context* viewedcontext, Context* fromcontext);
void clear_one_context(Context* self);
void help_clear_context(Context* self);
void clear_context(Context* self);
void call_clear_module(Cons* name);
void call_clear_module_evaluator_wrapper(Cons* arguments);
void clear_module(Cons* name);
void clear_module_evaluator_wrapper(Cons* arguments);
void help_startup_modules1();
void help_startup_modules2();
void startup_modules();

// Auxiliary global declarations:
extern Keyword* KWD_MODULES_CLEAR;
extern Surrogate* SGT_MODULES_STELLA_MODULE;
extern Surrogate* SGT_MODULES_STELLA_UNKNOWN_SURROGATE;
extern Symbol* SYM_MODULES_STELLA_UNKNOWN_SYMBOL;
extern Symbol* SYM_MODULES_STELLA_NAME;
extern Surrogate* SGT_MODULES_STELLA_MUTABLE_STRING_WRAPPER;
extern Symbol* SYM_MODULES_STELLA_SHADOWED_SURROGATES;
extern Surrogate* SGT_MODULES_STELLA_CONS;
extern Keyword* KWD_MODULES_INCLUDES;
extern Keyword* KWD_MODULES_USES;
extern Keyword* KWD_MODULES_SHADOW;
extern Keyword* KWD_MODULES_DOCUMENTATION;
extern Keyword* KWD_MODULES_CASE_SENSITIVEp;
extern Symbol* SYM_MODULES_STELLA_TRUE;
extern Keyword* KWD_MODULES_APIp;
extern Symbol* SYM_MODULES_STELLA_APIp;
extern Keyword* KWD_MODULES_LISP_PACKAGE;
extern Symbol* SYM_MODULES_STELLA_MODULE_LISP_PACKAGE;
extern Keyword* KWD_MODULES_CPP_PACKAGE;
extern Symbol* SYM_MODULES_STELLA_MODULE_CPP_PACKAGE;
extern Keyword* KWD_MODULES_JAVA_PACKAGE;
extern Symbol* SYM_MODULES_STELLA_JAVA_PACKAGE;
extern Keyword* KWD_MODULES_JAVA_CATCHALL_CLASS;
extern Symbol* SYM_MODULES_STELLA_JAVA_FLOTSAM_CLASS;
extern Keyword* KWD_MODULES_NICKNAME;
extern Keyword* KWD_MODULES_CLEARABLEp;
extern Symbol* SYM_MODULES_STELLA_CLEARABLEp;
extern Keyword* KWD_MODULES_PROTECT_SURROGATESp;
extern Symbol* SYM_MODULES_STELLA_PROTECT_SURROGATESp;
extern Keyword* KWD_MODULES_CODE_ONLYp;
extern Symbol* SYM_MODULES_STELLA_CODE_ONLYp;
extern Keyword* KWD_MODULES_REQUIRES;
extern Keyword* KWD_MODULES_DESTROY;
extern Keyword* KWD_MODULES_PRESERVE;
extern Keyword* KWD_MODULES_PREORDER;
extern Surrogate* SGT_MODULES_STELLA_WORLD;
extern Symbol* SYM_MODULES_STELLA_DEFINE_MODULE_FROM_STRINGIFIED_SOURCE;
extern Symbol* SYM_MODULES_STELLA_WORLD_NAME;
extern Keyword* KWD_MODULES_POSTORDER;
extern Keyword* KWD_MODULES_INORDER;
extern Symbol* SYM_MODULES_STELLA_STARTUP_MODULES;
extern Symbol* SYM_MODULES_STELLA_METHOD_STARTUP_CLASSNAME;


} // end of namespace stella
