//  -*- Mode: Java -*-
//
// /tmp/build-stella/stella-3.0.0.beta/native/java/edu/isi/stella/StartupSystems.java

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/

package edu.isi.stella;

import edu.isi.stella.javalib.*;

public class StartupSystems {
  static void helpStartupSystems1() {
    {
      Stella.SYM_STELLA_IN_MODULE = ((Symbol)(Stella.internRigidSymbolWrtModule("IN-MODULE", null, 0)));
      Stella.SYM_STELLA_DEFSYSTEM = ((Symbol)(Stella.internRigidSymbolWrtModule("DEFSYSTEM", null, 0)));
      Stella.KWD_FILES = ((Keyword)(Stella.internRigidSymbolWrtModule("FILES", null, 2)));
      Stella.KWD_REQUIRED_SYSTEMS = ((Keyword)(Stella.internRigidSymbolWrtModule("REQUIRED-SYSTEMS", null, 2)));
      Stella.KWD_LISP_ONLY_FILES = ((Keyword)(Stella.internRigidSymbolWrtModule("LISP-ONLY-FILES", null, 2)));
      Stella.KWD_CPP_ONLY_FILES = ((Keyword)(Stella.internRigidSymbolWrtModule("CPP-ONLY-FILES", null, 2)));
      Stella.KWD_JAVA_ONLY_FILES = ((Keyword)(Stella.internRigidSymbolWrtModule("JAVA-ONLY-FILES", null, 2)));
      Stella.KWD_PREPROCESSED_FILES = ((Keyword)(Stella.internRigidSymbolWrtModule("PREPROCESSED-FILES", null, 2)));
      Stella.KWD_CARDINAL_MODULE = ((Keyword)(Stella.internRigidSymbolWrtModule("CARDINAL-MODULE", null, 2)));
      Stella.KWD_ROOT_SOURCE_DIRECTORY = ((Keyword)(Stella.internRigidSymbolWrtModule("ROOT-SOURCE-DIRECTORY", null, 2)));
      Stella.KWD_ROOT_NATIVE_DIRECTORY = ((Keyword)(Stella.internRigidSymbolWrtModule("ROOT-NATIVE-DIRECTORY", null, 2)));
      Stella.KWD_ROOT_BINARY_DIRECTORY = ((Keyword)(Stella.internRigidSymbolWrtModule("ROOT-BINARY-DIRECTORY", null, 2)));
      Stella.KWD_BANNER = ((Keyword)(Stella.internRigidSymbolWrtModule("BANNER", null, 2)));
      Stella.KWD_COPYRIGHT_HEADER = ((Keyword)(Stella.internRigidSymbolWrtModule("COPYRIGHT-HEADER", null, 2)));
      Stella.KWD_PRODUCTION_SETTINGS = ((Keyword)(Stella.internRigidSymbolWrtModule("PRODUCTION-SETTINGS", null, 2)));
      Stella.KWD_DEVELOPMENT_SETTINGS = ((Keyword)(Stella.internRigidSymbolWrtModule("DEVELOPMENT-SETTINGS", null, 2)));
      Stella.KWD_FINALIZATION_FUNCTION = ((Keyword)(Stella.internRigidSymbolWrtModule("FINALIZATION-FUNCTION", null, 2)));
      Stella.KWD_FORCE_RECOMPILATIONp = ((Keyword)(Stella.internRigidSymbolWrtModule("FORCE-RECOMPILATION?", null, 2)));
      Stella.KWD_LOAD_SYSTEMp = ((Keyword)(Stella.internRigidSymbolWrtModule("LOAD-SYSTEM?", null, 2)));
      Stella.KWD_STARTUPp = ((Keyword)(Stella.internRigidSymbolWrtModule("STARTUP?", null, 2)));
      Stella.SYM_STELLA_SYSTEM_STARTED_UPp = ((Symbol)(Stella.internRigidSymbolWrtModule("SYSTEM-STARTED-UP?", null, 0)));
      Stella.KWD_EARLY_INITS = ((Keyword)(Stella.internRigidSymbolWrtModule("EARLY-INITS", null, 2)));
      Stella.SYM_STELLA_STARTUP = ((Symbol)(Stella.internRigidSymbolWrtModule("STARTUP", null, 0)));
      Stella.SYM_STELLA_PHASE = ((Symbol)(Stella.internRigidSymbolWrtModule("PHASE", null, 0)));
      Stella.SYM_STELLA_CONFIGURATION_TABLE = ((Symbol)(Stella.internRigidSymbolWrtModule("CONFIGURATION-TABLE", null, 0)));
      Stella.SYM_STELLA_STARTUP_SYSTEMS = ((Symbol)(Stella.internRigidSymbolWrtModule("STARTUP-SYSTEMS", null, 0)));
    }
  }

  public static void startupSystems() {
    { Object old$Module$000 = Stella.$MODULE$.get();
      Object old$Context$000 = Stella.$CONTEXT$.get();

      try {
        edu.isi.stella.javalib.Native.setSpecial(Stella.$MODULE$, Stella.$STELLA_MODULE$);
        edu.isi.stella.javalib.Native.setSpecial(Stella.$CONTEXT$, ((Module)(Stella.$MODULE$.get())));
        if (Stella.currentStartupTimePhaseP(2)) {
          StartupSystems.helpStartupSystems1();
        }
        if (Stella.currentStartupTimePhaseP(4)) {
          Stella.$SYSTEMDEFINITIONS$ = List.newList();
          Stella.$SYSTEM_CONFIGURATION_TABLE$ = KeyValueList.newKeyValueList();
        }
        if (Stella.currentStartupTimePhaseP(5)) {
          Stella.defineStellaTypeFromStringifiedSource("(DEFTYPE CONFIGURATION-TABLE (KEY-VALUE-LIST OF STRING-WRAPPER WRAPPER))");
        }
        if (Stella.currentStartupTimePhaseP(6)) {
          Stella.finalizeClasses();
        }
        if (Stella.currentStartupTimePhaseP(7)) {
          Stella.defineFunctionObject("EVALUATE-COMMAND", "(DEFUN (EVALUATE-COMMAND OBJECT) ((COMMAND OBJECT) (FINALIZE? BOOLEAN)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella_Object", "evaluateCommand", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Stella_Object"), java.lang.Boolean.TYPE}), null);
          Stella.defineFunctionObject("LOAD-FILE", "(DEFUN LOAD-FILE ((FILE STRING)) :DOCUMENTATION \"Read logic commands from `file' and evaluate them.\nThe file should begin with an `in-module' declaration that specifies\nthe module within which all remaining commands are to be evaluated\nThe remaining commands are evaluated one-by-one, applying the function\n`evaluate' to each of them.\" :COMMAND? TRUE :PUBLIC? TRUE)", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "loadFile", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String")}), edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Cons", "loadFileEvaluatorWrapper", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Cons")}));
          Stella.defineFunctionObject("MAKE-SYSTEM-DEFINITION-FILE-NAME", "(DEFUN (MAKE-SYSTEM-DEFINITION-FILE-NAME FILE-NAME) ((NAME STRING)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "makeSystemDefinitionFileName", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String")}), null);
          Stella.defineFunctionObject("PARSE-LIST-OF-FILE-PATHS", "(DEFUN (PARSE-LIST-OF-FILE-PATHS (CONS OF STRING-WRAPPER)) ((FILES CONS)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Cons", "parseListOfFilePaths", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Cons")}), null);
          Stella.defineFunctionObject("DEFINE-SYSTEM", "(DEFUN (DEFINE-SYSTEM SYSTEM-DEFINITION) ((NAME OBJECT) (OPTIONS CONS)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella_Object", "defineSystem", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Stella_Object"), edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Cons")}), null);
          Stella.defineFunctionObject("DEFSYSTEM", "(DEFUN (DEFSYSTEM SYSTEM-DEFINITION) ((NAME SYMBOL) |&REST| (OPTIONS OBJECT)) :COMMAND? TRUE :EVALUATE-ARGUMENTS? FALSE :PUBLIC? TRUE :DOCUMENTATION \"Define a system of files that collectively define\na Stella application.\n   Required options are:\n   :directory -- the path from the Stella root directory to the directory\n                 containing the system files.  Can be a string or a list\n                 of strings (do not include directory separators).\n   :files -- a list of files in the system, containing strings and lists\n             of strings; the latter defines exploded paths to files\n             in subdirectories.\n   Optional options are:\n   :required-systems -- a list of systems (strings) that should be loaded\n                        prior to loading this system.\n   :cardinal-module -- the name (a string) of the principal module for this\n                       system.\")", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Symbol", "defsystem", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Symbol"), edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Cons")}), edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Cons", "defsystemEvaluatorWrapper", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Cons")}));
          Stella.defineFunctionObject("GET-SYSTEM-DEFINITION", "(DEFUN (GET-SYSTEM-DEFINITION SYSTEM-DEFINITION) ((NAME STRING)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "getSystemDefinition", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String")}), null);
          Stella.defineFunctionObject("GET-CARDINAL-MODULE", "(DEFUN (GET-CARDINAL-MODULE MODULE) ((SYSTEM SYSTEM-DEFINITION)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.SystemDefinition", "getCardinalModule", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.SystemDefinition")}), null);
          Stella.defineFunctionObject("HELP-GET-SYSTEM-FILES", "(DEFUN HELP-GET-SYSTEM-FILES ((FILENAME FILE-NAME) (COLLECTION LIST) (PROBEFILE? BOOLEAN)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "helpGetSystemFiles", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String"), edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.List"), java.lang.Boolean.TYPE}), null);
          Stella.defineFunctionObject("GET-SYSTEM-FILES", "(DEFUN (GET-SYSTEM-FILES (LIST OF STRING-WRAPPER)) ((SYSTEM SYSTEM-DEFINITION) (TYPE KEYWORD) (PROBEFILES? BOOLEAN)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.SystemDefinition", "getSystemFiles", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.SystemDefinition"), edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Keyword"), java.lang.Boolean.TYPE}), null);
          Stella.defineFunctionObject("CLEAN-SYSTEM", "(DEFUN CLEAN-SYSTEM ((SYSTEMNAME STRING)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "cleanSystem", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String")}), null);
          Stella.defineFunctionObject("COMPUTE-OPTIMIZATION-LEVELS", "(DEFUN COMPUTE-OPTIMIZATION-LEVELS ((SYSTEM SYSTEM-DEFINITION) (PRODUCTIONMODE? BOOLEAN)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.SystemDefinition", "computeOptimizationLevels", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.SystemDefinition"), java.lang.Boolean.TYPE}), null);
          Stella.defineFunctionObject("LISP-KEYWORD-TO-STELLA-KEYWORD", "(DEFUN (LISP-KEYWORD-TO-STELLA-KEYWORD KEYWORD) ((KEY KEYWORD)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Keyword", "lispKeywordToStellaKeyword", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Keyword")}), null);
          Stella.defineFunctionObject("VET-OPTIONS", "(DEFUN (VET-OPTIONS PROPERTY-LIST) ((PLIST OBJECT) (LEGALOPTIONS (CONS OF KEYWORD))))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella_Object", "vetOptions", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Stella_Object"), edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Cons")}), null);
          Stella.defineFunctionObject("MAKE-SYSTEM", "(DEFUN (MAKE-SYSTEM BOOLEAN) ((SYSTEMNAME STRING) (LANGUAGE KEYWORD) |&REST| (OPTIONS OBJECT)) :DOCUMENTATION \"Translate, compile and load all out-of-date files in `files'.\nIf :development-settings? is set, translate with safety set to high; otherwise,\nuse production mode settings (defined in the 'defsystem').\nIf :force-recompilation? is `true', retranslate/recompile the entire system.\nIf :two-pass?, the translator makes two passes over the source files.\nOtherwise, the translator will make one pass in the case that the\nsystem is already loaded (and is being remade), and two passes otherwise.\nRuns system startup functions unless :startup? is set to `false'.\nIf :load-system? is FALSE, then files are translated but not loaded.\" :PUBLIC? TRUE :COMMAND? TRUE)", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "makeSystem", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String"), edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Keyword"), edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Cons")}), edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Cons", "makeSystemEvaluatorWrapper", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Cons")}));
          Stella.defineFunctionObject("RUN-SYSTEM-FINALIZATION", "(DEFUN RUN-SYSTEM-FINALIZATION ((SYSTEM SYSTEM-DEFINITION)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.SystemDefinition", "runSystemFinalization", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.SystemDefinition")}), null);
          Stella.defineFunctionObject("SYSTEM-DEFINITION-SOURCE-FILES", "(DEFUN (SYSTEM-DEFINITION-SOURCE-FILES (CONS OF STRING-WRAPPER)) ((SYSTEM SYSTEM-DEFINITION)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.SystemDefinition", "systemDefinitionSourceFiles", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.SystemDefinition")}), null);
          Stella.defineFunctionObject("FILES-PLUS-SYSTEM-STARTUP", "(DEFUN (FILES-PLUS-SYSTEM-STARTUP (CONS OF STRING-WRAPPER)) ((FILES (CONS OF STRING-WRAPPER))))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Cons", "filesPlusSystemStartup", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Cons")}), null);
          Stella.defineFunctionObject("SYSTEM-DEFINITION-NATIVE-FILES", "(DEFUN (SYSTEM-DEFINITION-NATIVE-FILES (CONS OF STRING-WRAPPER)) ((SYSTEM SYSTEM-DEFINITION)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.SystemDefinition", "systemDefinitionNativeFiles", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.SystemDefinition")}), null);
          Stella.defineFunctionObject("SYSTEM-LOADED?", "(DEFUN (SYSTEM-LOADED? BOOLEAN) ((NAME STRING)) :DOCUMENTATION \"Return `true' if system `name' has been loaded.\" :PUBLIC? TRUE)", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "systemLoadedP", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String")}), null);
          Stella.defineFunctionObject("LOAD-PREPROCESSED-FILES", "(DEFUN LOAD-PREPROCESSED-FILES ((SYSTEMNAME STRING)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "loadPreprocessedFiles", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String")}), null);
          Stella.defineFunctionObject("LOAD-SYSTEM", "(DEFUN (LOAD-SYSTEM BOOLEAN) ((SYSTEMNAME STRING) (LANGUAGE KEYWORD) |&REST| (OPTIONS OBJECT)) :DOCUMENTATION \"Load (and compile out-of-date files) a simple system of 'files'.\" :PUBLIC? TRUE)", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "loadSystem", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String"), edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Keyword"), edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Cons")}), null);
          Stella.defineFunctionObject("COMPILE-AND-LOAD-FILE", "(DEFUN (COMPILE-AND-LOAD-FILE BOOLEAN) ((FILE FILE-NAME) (LANGUAGE KEYWORD) (FORCERECOMPILATION? BOOLEAN)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "compileAndLoadFile", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String"), edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Keyword"), java.lang.Boolean.TYPE}), null);
          Stella.defineFunctionObject("RUN-SYSTEM-STARTUP-FUNCTION", "(DEFUN RUN-SYSTEM-STARTUP-FUNCTION ((SYSTEM SYSTEM-DEFINITION)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.SystemDefinition", "runSystemStartupFunction", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.SystemDefinition")}), null);
          Stella.defineMethodObject("(DEFMETHOD (SYSTEM-STARTUP-FUNCTION-NAME STRING) ((SYSTEM SYSTEM-DEFINITION)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.SystemDefinition", "systemStartupFunctionName", new java.lang.Class [] {}), ((java.lang.reflect.Method)(null)));
          Stella.defineMethodObject("(DEFMETHOD (SYSTEM-STARTUP-FUNCTION-NAME STRING) ((SYSTEMNAME STRING)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "string_systemStartupFunctionName", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String")}), ((java.lang.reflect.Method)(null)));
          Stella.defineFunctionObject("SYSTEM-STARTUP-FUNCTION-SYMBOL", "(DEFUN (SYSTEM-STARTUP-FUNCTION-SYMBOL SYMBOL) ((SYSTEM SYSTEM-DEFINITION)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.SystemDefinition", "systemStartupFunctionSymbol", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.SystemDefinition")}), null);
          Stella.defineFunctionObject("STARTUP-NAME-FROM-FILE", "(DEFUN (STARTUP-NAME-FROM-FILE SYMBOL) ((FILE FILE-NAME)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "startupNameFromFile", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String")}), null);
          Stella.defineFunctionObject("STARTUP-NAMES-FROM-FILES", "(DEFUN (STARTUP-NAMES-FROM-FILES (CONS OF SYMBOL)) ((FILES (CONS OF STRING-WRAPPER))))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Cons", "startupNamesFromFiles", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Cons")}), null);
          Stella.defineFunctionObject("SYSTEM-STARTUP-FILE-NAME", "(DEFUN (SYSTEM-STARTUP-FILE-NAME STRING) ((SYSTEM SYSTEM-DEFINITION)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.SystemDefinition", "systemStartupFileName", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.SystemDefinition")}), null);
          Stella.defineFunctionObject("SYSTEM-STARTUP-FILE?", "(DEFUN (SYSTEM-STARTUP-FILE? BOOLEAN) ((FILE FILE-NAME)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "systemStartupFileP", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String")}), null);
          Stella.defineFunctionObject("SYSTEM-STARTED-UP?", "(DEFUN (SYSTEM-STARTED-UP? BOOLEAN) ((SYSTEMNAME STRING) (SYSTEMMODULENAME STRING)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "systemStartedUpP", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String"), edu.isi.stella.javalib.Native.find_java_class("java.lang.String")}), null);
          Stella.defineFunctionObject("YIELD-STARTUP-REQUIRED-SYSTEMS", "(DEFUN (YIELD-STARTUP-REQUIRED-SYSTEMS CONS) ((SYSTEM SYSTEM-DEFINITION)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.SystemDefinition", "yieldStartupRequiredSystems", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.SystemDefinition")}), null);
          Stella.defineFunctionObject("COLLECT-STARTUP-FORMS-FROM-SYSTEM-FILE", "(DEFUN (COLLECT-STARTUP-FORMS-FROM-SYSTEM-FILE (CONS OF CONS)) ((SYSTEM SYSTEM-DEFINITION)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.SystemDefinition", "collectStartupFormsFromSystemFile", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.SystemDefinition")}), null);
          Stella.defineFunctionObject("CREATE-SYSTEM-STARTUP-FILE", "(DEFUN CREATE-SYSTEM-STARTUP-FILE ((SYSTEM SYSTEM-DEFINITION)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.SystemDefinition", "createSystemStartupFile", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.SystemDefinition")}), null);
          Stella.defineFunctionObject("MAKE-STELLA", "(DEFUN MAKE-STELLA ((FORCERECOMPILATION? BOOLEAN)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "makeStella", new java.lang.Class [] {java.lang.Boolean.TYPE}), null);
          Stella.defineFunctionObject("PARSE-CONFIGURATION-FILE-LINE", "(DEFUN (PARSE-CONFIGURATION-FILE-LINE STRING-WRAPPER WRAPPER) ((LINE STRING)))", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "parseConfigurationFileLine", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String"), edu.isi.stella.javalib.Native.find_java_class("[Ljava.lang.Object;")}), null);
          Stella.defineFunctionObject("LOAD-CONFIGURATION-FILE", "(DEFUN (LOAD-CONFIGURATION-FILE CONFIGURATION-TABLE) ((FILE FILE-NAME)) :DOCUMENTATION \"Read a configuration `file' and return its content as a configuration table.\nAlso enter each property read into the global system configuration table.\nAssumes Java-style property file syntax.  Each property name is represented\nas a wrapped string and each value as a wrapped string/integer/float or boolean.\" :PUBLIC? TRUE)", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "loadConfigurationFile", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String")}), null);
          Stella.defineFunctionObject("LOOKUP-CONFIGURATION-PROPERTY", "(DEFUN (LOOKUP-CONFIGURATION-PROPERTY WRAPPER) ((PROPERTY STRING) (DEFAULTVALUE WRAPPER) (CONFIGURATION CONFIGURATION-TABLE)) :DOCUMENTATION \"Lookup `property' in `configuration' and return its value.\nUse the global system configuration table if `configuration' is NULL.  Return\n`defaultValue' if `property' is not defined.\" :PUBLIC? TRUE)", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "lookupConfigurationProperty", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String"), edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Wrapper"), edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.KeyValueList")}), null);
          Stella.defineFunctionObject("SET-CONFIGURATION-PROPERTY", "(DEFUN (SET-CONFIGURATION-PROPERTY WRAPPER) ((PROPERTY STRING) (VALUE WRAPPER) (CONFIGURATION CONFIGURATION-TABLE)) :DOCUMENTATION \"Set `property' in `configuration' to `value' and return it.\nUse the global system configuration table if `configuration' is NULL.\" :PUBLIC? TRUE)", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "setConfigurationProperty", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String"), edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.Wrapper"), edu.isi.stella.javalib.Native.find_java_class("edu.isi.stella.KeyValueList")}), null);
          Stella.defineFunctionObject("CONFIGURE-STELLA", "(DEFUN CONFIGURE-STELLA ((FILE FILE-NAME)) :DOCUMENTATION \"Perform STELLA run-time configuration.  If supplied, load the\nconfiguration file `file' first which should be supplied with a physical pathname.\" :PUBLIC? TRUE)", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.Stella", "configureStella", new java.lang.Class [] {edu.isi.stella.javalib.Native.find_java_class("java.lang.String")}), null);
          Stella.defineFunctionObject("STARTUP-SYSTEMS", "(DEFUN STARTUP-SYSTEMS () :PUBLIC? TRUE)", edu.isi.stella.javalib.Native.find_java_method("edu.isi.stella.StartupSystems", "startupSystems", new java.lang.Class [] {}), null);
          { MethodSlot function = Symbol.lookupFunction(Stella.SYM_STELLA_STARTUP_SYSTEMS);

            KeyValueList.setDynamicSlotValue(function.dynamicSlots, Stella.SYM_STELLA_METHOD_STARTUP_CLASSNAME, Stella.wrapString("Startup-Systems"), Stella.NULL_STRING_WRAPPER);
          }
        }
        if (Stella.currentStartupTimePhaseP(8)) {
          Stella.finalizeSlots();
          Stella.cleanupUnfinalizedClasses();
        }
        if (Stella.currentStartupTimePhaseP(9)) {
          Stella.defineStellaGlobalVariableFromStringifiedSource("(DEFGLOBAL *SYSTEMDEFINITIONS* (LIST OF SYSTEM-DEFINITION) (NEW LIST) :DOCUMENTATION \"A list of all defined systems.\")");
          Stella.defineStellaGlobalVariableFromStringifiedSource("(DEFGLOBAL *SYSTEM-CONFIGURATION-TABLE* CONFIGURATION-TABLE (NEW CONFIGURATION-TABLE))");
        }

      } finally {
        Stella.$CONTEXT$.set(old$Context$000);
        Stella.$MODULE$.set(old$Module$000);
      }
    }
  }

}
